/*****************************************************************
 program: syscoltoppm
 purpose: create ppm data containing all system colors (8-bit)
          for 8-bit-conversion of 24-bit ppm files
          e.g. syscoltoppm >syscol.ppm
               screentoppm screen1 | ppmtogif -map syscol.ppm >screen1.gif
 author : Gertjan van Ratingen
 date   : 8-feb-1997

 usage: syscoltoppm
 output will be sent to stdout, in binary rgb format (P6)
*****************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <interface/InterfaceDefs.h>
#include <app/Application.h>

main(int argc, char **argv)
{
	int i;
	unsigned char rgb[3];
	color_map *colmap;
	rgb_color *sys_colors;

	// need to contruct a BApplication so system_colors() will work
	new BApplication('????');

	colmap = system_colors();
	if (colmap == NULL)
	{
		fprintf(stderr, "Cannot find colormap");
	}
	else
	{
		sys_colors = colmap->color_list;
		printf("P6\n32 8\n255\n");
		for(i=0; i<256;i++)
		{
			rgb[0] = sys_colors[i].red;
			rgb[1] = sys_colors[i].green;
			rgb[2] = sys_colors[i].blue;
			fwrite(rgb, 3, 1, stdout); /* only 3 bytes rgb */
		}
	}

	delete be_app;
	return 0;
}

